package main;

public class Building extends Location implements Entity {
	private int color;
	private int teamColor;
	private int a;
	private boolean isSendingUnitOut;
	private int health;
	private boolean shouldDespawn;
	private int renderX, renderY;

	public Building() {
		a = 0;
		isSendingUnitOut = false;
		shouldDespawn = false;
		health = 0xFF;
	}
	
	public void setColor(int c) {
		color = c;
		teamColor = c;

	}

	public void tick() {
		if (a == 0xFF) {
			//Send out 1 unit to attack the opposing team.
			isSendingUnitOut = true;
		}
	}
	
	public void render(int[] data) {
		renderX = ((int) Math.rint(this.x)) / GameComponent.SCALE;
		renderY = ((int) Math.rint(this.y)) / GameComponent.SCALE;
		int length = renderY * (GameComponent.WIDTH / GameComponent.SCALE) + renderX;
		if (length < data.length && length >= 0)
			data[length] = color;
		counter(); 		//Accurately counts up once every 60 ticks.
	}
	
	private void counter() {
		if (isSendingUnitOut == false)
			a += 0x01;
		color = (color & ~(0xFF << 24)) | (a << 24);
		// color = (color & ~(0xFF << 16)) | (r << 16);
		// color = (color & ~(0xFF << 8)) | (g << 8);
		// color = (color & ~(0xFF)) | (b);
		if (a > 0xFF) {
			a = 0x00;
		}
	}
	
	public boolean isSendingUnitOut() {
		return isSendingUnitOut;
	}
	
	public void finishedSendingUnitOut() {
		isSendingUnitOut = false;
	}

	public int getColor() {
		return color;
	}
	
	public int getTeamColor() {
		return teamColor;
	}
	
	public int getHealth() {
		return health;
	}
	
	public void takeDamage(Unit u) {
		if (u.teamColor != this.teamColor) {
			//			int shift = 0;
			//			for (; shift < 24; shift += 8) {
			//				health = (teamColor & (0xFF << shift)) >> shift;
			//				if (health != 0)
			//					break;
			//			}
			double dx = Math.floor(this.x) - Math.floor(u.x);
			double dy = Math.floor(this.y) - Math.floor(u.y);
			if (Math.abs(dx) < 1.0 && Math.abs(dy) < 1.0) {
				health -= 0x44;
				u.despawn();
			}
			//			if ((Math.floor(this.x) == Math.floor(u.x) || Math.ceil(this.x) == Math.ceil(u.x)) && (Math.floor(this.y) == Math.floor(u.y) || Math.ceil(this.y) == Math.ceil(u.y))) {
			//				health -= 0x44;
			//				u.despawn();
			//			}
			//color = (color & ~(0xFF << shift)) | (health << shift);
			//teamColor = (teamColor & ~(0xFF << shift)) | (health << shift);
		}
		if (health <= 0) {
			this.shouldDespawn = true;
		}
	}
	
	public boolean shouldDespawn() {
		return shouldDespawn;
	}
}
